"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImmutableMethodResults = exports.RegistrationMethodParams = exports.StarkMethodParams = exports.ImmutableMethodParams = exports.ImmutableFeeType = exports.ImmutableRollupStatusCodec = exports.ImmutableRollupStatus = exports.ImmutableAssetStatusCodec = exports.ImmutableAssetStatus = exports.ImmutableTransactionStatusCodec = exports.ImmutableTransactionStatus = exports.ImmutableOrderStatusCodec = exports.ImmutableOrderStatus = void 0;
var t = __importStar(require("io-ts"));
var io_ts_types_1 = require("io-ts-types");
var runtime_1 = require("./runtime");
var ImmutableOrderStatus;
(function (ImmutableOrderStatus) {
    ImmutableOrderStatus["created"] = "created";
    ImmutableOrderStatus["accepted"] = "accepted";
    ImmutableOrderStatus["partially_filled"] = "partially_filled";
    ImmutableOrderStatus["filled"] = "filled";
    ImmutableOrderStatus["cancelled"] = "cancelled";
    ImmutableOrderStatus["expired"] = "expired";
    ImmutableOrderStatus["pending"] = "pending";
    ImmutableOrderStatus["active"] = "active";
})(ImmutableOrderStatus = exports.ImmutableOrderStatus || (exports.ImmutableOrderStatus = {}));
exports.ImmutableOrderStatusCodec = runtime_1.fromEnum('ImmutableOrderStatus', ImmutableOrderStatus);
var ImmutableTransactionStatus;
(function (ImmutableTransactionStatus) {
    ImmutableTransactionStatus["pending"] = "pending";
    ImmutableTransactionStatus["accepted"] = "accepted";
    ImmutableTransactionStatus["rejected"] = "rejected";
    ImmutableTransactionStatus["confirmed"] = "confirmed";
    ImmutableTransactionStatus["rolledBack"] = "rolledBack";
    ImmutableTransactionStatus["withdrawn"] = "withdrawn";
    ImmutableTransactionStatus["success"] = "success";
})(ImmutableTransactionStatus = exports.ImmutableTransactionStatus || (exports.ImmutableTransactionStatus = {}));
exports.ImmutableTransactionStatusCodec = runtime_1.fromEnum('ImmutableTransactionStatus', ImmutableTransactionStatus);
var ImmutableAssetStatus;
(function (ImmutableAssetStatus) {
    ImmutableAssetStatus["imx"] = "imx";
    ImmutableAssetStatus["eth"] = "eth";
    ImmutableAssetStatus["preparing_withdrawal"] = "preparing_withdrawal";
    ImmutableAssetStatus["withdrawable"] = "withdrawable";
})(ImmutableAssetStatus = exports.ImmutableAssetStatus || (exports.ImmutableAssetStatus = {}));
exports.ImmutableAssetStatusCodec = runtime_1.fromEnum('ImmutableAssetStatus', ImmutableAssetStatus);
var ImmutableRollupStatus;
(function (ImmutableRollupStatus) {
    ImmutableRollupStatus["included"] = "included";
    ImmutableRollupStatus["confirmed"] = "confirmed";
})(ImmutableRollupStatus = exports.ImmutableRollupStatus || (exports.ImmutableRollupStatus = {}));
exports.ImmutableRollupStatusCodec = runtime_1.fromEnum('ImmutableRollupStatus', ImmutableRollupStatus);
var ImmutableFeeType;
(function (ImmutableFeeType) {
    ImmutableFeeType["royalty"] = "royalty";
    ImmutableFeeType["ecosystem"] = "ecosystem";
    ImmutableFeeType["protocol"] = "protocol";
})(ImmutableFeeType = exports.ImmutableFeeType || (exports.ImmutableFeeType = {}));
var ImmutableMethodParams;
(function (ImmutableMethodParams) {
    ImmutableMethodParams.ImmutableRegisterParamsCodec = t.type({
        etherKey: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
    });
    ImmutableMethodParams.ImmutableStarkRegisterParamsCodec = t.type({
        etherKey: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        operatorSignature: t.string,
    });
    ImmutableMethodParams.ImmutableGetUserParamsCodec = t.type({
        user: runtime_1.EthAddress,
    });
    ImmutableMethodParams.ImmutableGetSignableDepositParamsCodec = t.type({
        user: runtime_1.EthAddress,
        token: runtime_1.TokenCodec,
        quantity: runtime_1.PositiveBigNumber,
    });
    ImmutableMethodParams.ImmutableGetSignableRegistrationParamsCodec = t.type({
        etherKey: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
    });
    ImmutableMethodParams.ImmutableDepositCancelParamsCodec = t.type({
        starkPublicKey: runtime_1.HexadecimalString,
        token: runtime_1.TokenCodec,
        vaultId: runtime_1.PositiveIntegerStringC,
    });
    ImmutableMethodParams.ImmutableDepositReclaimParamsCodec = t.type({
        starkPublicKey: runtime_1.HexadecimalString,
        token: runtime_1.TokenCodec,
        vaultId: runtime_1.PositiveIntegerStringC,
    });
    ImmutableMethodParams.ImmutableWithdrawalParamsCodec = t.type({
        starkPublicKey: runtime_1.HexadecimalString,
        quantity: runtime_1.PositiveBigNumber,
        token: runtime_1.TokenCodec,
        vaultId: runtime_1.PositiveIntegerStringC,
        nonce: runtime_1.PositiveIntegerStringC,
    });
    ImmutableMethodParams.ImmutableGetSignableWithdrawalParamsCodec = t.type({
        user: runtime_1.EthAddress,
        token: runtime_1.TokenCodec,
        quantity: runtime_1.PositiveBigNumber,
    });
    ImmutableMethodParams.ImmutableTransferParamsCodec = t.type({
        sender: runtime_1.EthAddress,
        token: runtime_1.TokenCodec,
        quantity: runtime_1.PositiveBigNumber,
        receiver: runtime_1.EthAddress,
    });
    ImmutableMethodParams.ImmutableOffchainMintParamsCodec = t.type({
        mints: t.array(runtime_1.MintBodyCodec),
    });
    // TODO: Remove V2 once V1 is deprecated
    ImmutableMethodParams.ImmutableOffchainMintV2ParamsCodec = t.type({
        mints: t.array(runtime_1.MintV2BodyCodec),
    });
    ImmutableMethodParams.ImmutableCreateOrderParamsCodec = t.type({
        starkPublicKey: runtime_1.HexadecimalString,
        sell: runtime_1.OrderParamsCodec,
        buy: runtime_1.OrderParamsCodec,
        nonce: runtime_1.PositiveIntegerStringC,
        expirationTimestamp: runtime_1.PositiveIntegerStringC,
        signature: t.string,
    });
    ImmutableMethodParams.ImmutableCancelOrderParamsCodec = t.type({
        starkPublicKey: runtime_1.HexadecimalString,
        orderId: runtime_1.PositiveIntegerStringC,
    });
    ImmutableMethodParams.ImmutableGetSignableOrderParamsCodec = t.type({
        user: runtime_1.EthAddress,
        tokenSell: runtime_1.TokenCodec,
        amountSell: runtime_1.PositiveBigNumber,
        tokenBuy: runtime_1.TokenCodec,
        amountBuy: runtime_1.PositiveBigNumber,
    });
    ImmutableMethodParams.ImmutableGetSignableTradeParamsCodec = t.intersection([
        t.type({
            orderId: t.Int,
        }),
        ImmutableMethodParams.ImmutableGetSignableOrderParamsCodec,
    ]);
    ImmutableMethodParams.ImmutableCreateTradeParamsCodec = t.type({
        starkPublicKey: runtime_1.HexadecimalString,
        sell: runtime_1.OrderParamsCodec,
        buy: runtime_1.OrderParamsCodec,
        nonce: runtime_1.PositiveIntegerStringC,
        expirationTimestamp: runtime_1.PositiveIntegerStringC,
        signature: t.string,
        orderId: runtime_1.PositiveIntegerStringC,
    });
    ImmutableMethodParams.ImmutableGetTokenParamsCodec = t.partial({
        /**
         * NOTE: 't.union([t.string, EthAddress])' is not used
         * here because 'tokenAddress' value defaults to 'eth'.
         */
        tokenAddress: runtime_1.EthAddress,
    });
    ImmutableMethodParams.ImmutableListTokensParamsCodec = t.partial({
        symbols: t.array(t.string),
        cursor: t.string,
    });
    // TODO: v1 endpoint to get balance, remove when it is deprecated
    ImmutableMethodParams.ImmutableGetBalancesParamsCodec = t.type({
        user: runtime_1.EthAddress,
    });
    ImmutableMethodParams.ImmutableGetBalanceParamsCodec = t.type({
        user: runtime_1.EthAddress,
        tokenAddress: t.union([t.string, runtime_1.EthAddress]),
    });
    ImmutableMethodParams.ImmutableListBalancesParamsCodec = t.intersection([
        t.type({ user: runtime_1.EthAddress }),
        t.partial({ cursor: t.string, symbols: t.array(t.string) }),
    ]);
    ImmutableMethodParams.ImmutableGetVaultsParamsCodec = t.type({
        starkPublicKey: runtime_1.HexadecimalString,
    });
    ImmutableMethodParams.ImmutableGetOrderParamsCodec = t.type({
        orderId: t.Int,
    });
    ImmutableMethodParams.ImmutableGetLastAvailableNonceParamsCodec = t.type({
        starkPublicKey: runtime_1.HexadecimalString,
    });
    var ImmutableSortOrder;
    (function (ImmutableSortOrder) {
        ImmutableSortOrder["asc"] = "asc";
        ImmutableSortOrder["desc"] = "desc";
    })(ImmutableSortOrder = ImmutableMethodParams.ImmutableSortOrder || (ImmutableMethodParams.ImmutableSortOrder = {}));
    ImmutableMethodParams.ImmutableSortOrderCodec = runtime_1.fromEnum('ImmutableSortOrder', ImmutableSortOrder);
    ImmutableMethodParams.ImmutablePaginatedParamsCodec = t.partial({
        order_by: t.string,
        page_size: t.Int,
        cursor: t.string,
        direction: ImmutableMethodParams.ImmutableSortOrderCodec,
    });
    ImmutableMethodParams.ImmutableGetOrdersParamsCodec = t.intersection([
        ImmutableMethodParams.ImmutablePaginatedParamsCodec,
        t.partial({
            user: runtime_1.EthAddress,
            status: exports.ImmutableOrderStatusCodec,
            min_timestamp: t.string,
            max_timestamp: t.string,
            buy_token_type: runtime_1.TokenTypeCodec,
            buy_token_id: t.string,
            buy_token_contract: runtime_1.EthAddress,
            buy_min_quantity: runtime_1.PositiveIntegerStringC,
            buy_max_quantity: runtime_1.PositiveIntegerStringC,
            buy_metadata: t.string,
            sell_token_type: runtime_1.TokenTypeCodec,
            sell_token_id: t.string,
            sell_token_address: runtime_1.EthAddress,
            sell_min_quantity: runtime_1.PositiveIntegerStringC,
            sell_max_quantity: runtime_1.PositiveIntegerStringC,
            sell_metadata: t.string,
        }),
    ]);
    ImmutableMethodParams.ImmutableGetAssetsParamsCodec = t.intersection([
        ImmutableMethodParams.ImmutablePaginatedParamsCodec,
        t.partial({
            user: runtime_1.EthAddress,
            status: exports.ImmutableAssetStatusCodec,
            metadata: t.string,
            collection: runtime_1.EthAddress,
            name: t.string,
            sell_orders: t.boolean,
            buy_orders: t.boolean,
        }),
    ]);
    ImmutableMethodParams.ImmutableGetCollectionsParamsCodec = ImmutableMethodParams.ImmutablePaginatedParamsCodec;
    ImmutableMethodParams.ImmutableGetApplicationsParamsCodec = ImmutableMethodParams.ImmutablePaginatedParamsCodec;
    ImmutableMethodParams.ImmutableGetTransactionParamsCodec = t.intersection([
        ImmutableMethodParams.ImmutablePaginatedParamsCodec,
        t.partial({
            user: runtime_1.EthAddress,
            receiver: runtime_1.EthAddress,
            status: exports.ImmutableTransactionStatusCodec,
            rollup_status: exports.ImmutableRollupStatusCodec,
            min_timestamp: t.string,
            max_timestamp: t.string,
            token_type: runtime_1.TokenTypeCodec,
            token_id: t.string,
            token_address: runtime_1.EthAddress,
            min_quantity: runtime_1.PositiveIntegerStringC,
            max_quantity: runtime_1.PositiveIntegerStringC,
            metadata: t.string,
        }),
    ]);
    ImmutableMethodParams.ImmutableGetDepositsParamsCodec = ImmutableMethodParams.ImmutableGetTransactionParamsCodec;
    ImmutableMethodParams.ImmutableGetWithdrawalsParamsCodec = t.intersection([
        ImmutableMethodParams.ImmutableGetTransactionParamsCodec,
        t.partial({
            withdrawn_to_wallet: t.boolean,
        }),
    ]);
    ImmutableMethodParams.ImmutableGetTransfersParamsCodec = ImmutableMethodParams.ImmutableGetTransactionParamsCodec;
    ImmutableMethodParams.ImmutableGetTradesParamsCodec = t.intersection([
        ImmutableMethodParams.ImmutablePaginatedParamsCodec,
        t.partial({
            status: exports.ImmutableTransactionStatusCodec,
            min_timestamp: t.string,
            max_timestamp: t.string,
        }),
    ]);
    ImmutableMethodParams.ImmutableGetAssetParamsCodec = t.type({
        address: runtime_1.HexadecimalString,
        id: io_ts_types_1.NonEmptyString,
    });
    ImmutableMethodParams.ImmutableGetCollectionParamsCodec = t.type({
        address: runtime_1.HexadecimalString,
    });
    ImmutableMethodParams.ImmutableGetDepositParamsCodec = t.type({
        id: t.Int,
    });
    ImmutableMethodParams.ImmutableGetTransferParamsCodec = t.type({
        id: t.Int,
    });
    ImmutableMethodParams.ImmutableGetWithdrawalParamsCodec = t.type({
        id: t.Int,
    });
    ImmutableMethodParams.ImmutableGetTradeParamsCodec = t.type({
        id: t.Int,
    });
    ImmutableMethodParams.ImmutableStarkApproveNFTParamsCodec = t.type({
        tokenAddress: runtime_1.EthAddress,
        tokenId: t.string,
    });
    ImmutableMethodParams.ImmutableMintNFTParamsCodec = t.type({
        tokenAddress: runtime_1.EthAddress,
    });
    ImmutableMethodParams.ImmutablePrepareWithdrawalParamsCodec = t.type({
        user: runtime_1.EthAddress,
        token: runtime_1.TokenCodec,
        quantity: runtime_1.PositiveBigNumber,
    });
    ImmutableMethodParams.ImmutableCompleteWithdrawalParamsCodec = t.type({
        starkPublicKey: runtime_1.HexadecimalString,
        token: runtime_1.TokenCodec,
    });
    ImmutableMethodParams.ImmutableGetMintableTokenParamsCodec = t.type({
        tokenAddress: t.string,
        tokenId: t.string,
    });
})(ImmutableMethodParams = exports.ImmutableMethodParams || (exports.ImmutableMethodParams = {}));
var StarkMethodParams;
(function (StarkMethodParams) {
    StarkMethodParams.StarkAccountParamsCodec = t.type({
        layer: t.string,
        application: t.string,
        index: runtime_1.PositiveIntegerStringC,
    });
    StarkMethodParams.StarkRegisterParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        etherKey: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        operatorSignature: t.string,
    });
    StarkMethodParams.StarkDepositParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        quantity: runtime_1.PositiveBigNumber,
        quantizedAmount: runtime_1.PositiveBigNumber,
        assetId: runtime_1.HexadecimalString,
        token: runtime_1.TokenCodec,
        vaultId: runtime_1.PositiveIntegerStringC,
    });
    StarkMethodParams.StarkDepositCancelParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        token: runtime_1.TokenCodec,
        vaultId: runtime_1.PositiveIntegerStringC,
    });
    StarkMethodParams.StarkDepositReclaimParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        token: runtime_1.TokenCodec,
        vaultId: runtime_1.PositiveIntegerStringC,
    });
    StarkMethodParams.StarkTransferParamsCodec = t.type({
        from: runtime_1.TransferParamsCodec,
        to: runtime_1.TransferParamsCodec,
        token: runtime_1.TokenCodec,
        quantity: runtime_1.PositiveBigNumber,
        nonce: runtime_1.PositiveIntegerStringC,
        expirationTimestamp: runtime_1.PositiveIntegerStringC,
    });
    StarkMethodParams.StarkCreateOrderParamsCodec = t.type({
        starkPublicKey: runtime_1.HexadecimalString,
        sell: runtime_1.OrderParamsCodec,
        buy: runtime_1.OrderParamsCodec,
        nonce: runtime_1.PositiveIntegerStringC,
        expirationTimestamp: runtime_1.PositiveIntegerStringC,
    });
    StarkMethodParams.StarkWithdrawalParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        token: runtime_1.TokenCodec,
    });
    StarkMethodParams.StarkFullWithdrawalParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        vaultId: runtime_1.PositiveIntegerStringC,
    });
    StarkMethodParams.StarkFreezeParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        vaultId: runtime_1.PositiveIntegerStringC,
    });
    StarkMethodParams.StarkVerifyEscapeParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        proof: t.array(t.string),
    });
    StarkMethodParams.StarkEscapeParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        vaultId: runtime_1.PositiveIntegerStringC,
        token: runtime_1.TokenCodec,
        quantity: runtime_1.PositiveBigNumber,
    });
    StarkMethodParams.StarkRegisterTokenParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        token: runtime_1.TokenCodec,
    });
    StarkMethodParams.StarkGetEthKeyParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        user: runtime_1.EthAddress,
    });
    StarkMethodParams.StarkGetDepositBalanceParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        token: runtime_1.TokenCodec,
        vaultId: runtime_1.PositiveIntegerStringC,
    });
    StarkMethodParams.StarkGetWithdrawalBalanceParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        token: runtime_1.TokenCodec,
    });
    StarkMethodParams.StarkMintNFTParamsCodec = t.type({
        tokenAddress: runtime_1.EthAddress,
        to: runtime_1.EthAddress,
        tokenId: t.string,
        tokenUri: t.string,
    });
    StarkMethodParams.StarkApproveNFTParamsCodec = t.type({
        contractAddress: runtime_1.EthAddress,
        tokenAddress: runtime_1.EthAddress,
        tokenId: t.string,
    });
    StarkMethodParams.StarkSetupNFTParamsCodec = t.type({
        tokenAddress: runtime_1.EthAddress,
        contractAddress: runtime_1.EthAddress,
        to: runtime_1.EthAddress,
        tokenId: t.string,
        tokenUri: t.string,
    });
})(StarkMethodParams = exports.StarkMethodParams || (exports.StarkMethodParams = {}));
var RegistrationMethodParams;
(function (RegistrationMethodParams) {
    RegistrationMethodParams.RegisterAndDepositParamsCodec = t.type({
        registrationContractAddress: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        quantity: runtime_1.PositiveBigNumber,
        quantizedAmount: runtime_1.PositiveBigNumber,
        assetId: runtime_1.HexadecimalString,
        token: runtime_1.TokenCodec,
        vaultId: runtime_1.PositiveIntegerStringC,
        etherKey: runtime_1.EthAddress,
        operatorSignature: t.string,
    });
    RegistrationMethodParams.RegisterAndWithdrawParamsCodec = t.type({
        registrationContractAddress: runtime_1.EthAddress,
        starkPublicKey: runtime_1.HexadecimalString,
        token: runtime_1.TokenCodec,
        etherKey: runtime_1.EthAddress,
        operatorSignature: t.string,
    });
})(RegistrationMethodParams = exports.RegistrationMethodParams || (exports.RegistrationMethodParams = {}));
var ImmutableMethodResults;
(function (ImmutableMethodResults) {
    ImmutableMethodResults.ImmutableRegisterResultCodec = t.type({
        tx_hash: t.string,
    });
    ImmutableMethodResults.ImmutableGetUserResultCodec = t.type({
        accounts: t.array(runtime_1.HexadecimalString),
    });
    ImmutableMethodResults.ImmutableGetSignableDepositResultCodec = t.type({
        stark_key: runtime_1.HexadecimalString,
        vault_id: t.Int,
        amount: runtime_1.PositiveBigNumber,
        asset_id: runtime_1.HexadecimalString,
        nonce: t.Int,
    });
    ImmutableMethodResults.ImmutableGetSignableRegistrationResultCodec = t.type({
        operator_signature: t.string,
    });
    ImmutableMethodResults.ImmutableDepositResultCodec = t.type({
        deposit_id: t.Int,
        status: t.string,
        time: t.Int,
    });
    ImmutableMethodResults.ImmutableGetSignableWithdrawalResultCodec = t.type({
        stark_key: runtime_1.HexadecimalString,
        vault_id: t.Int,
        amount: runtime_1.PositiveBigNumber,
        asset_id: runtime_1.HexadecimalString,
        nonce: t.Int,
    });
    ImmutableMethodResults.ImmutableWithdrawalResultCodec = t.type({
        withdrawal_id: t.Int,
        status: t.string,
        time: t.Int,
    });
    ImmutableMethodResults.ImmutableGetSignableTransferResultCodec = t.type({
        sender_stark_key: runtime_1.HexadecimalString,
        sender_vault_id: t.Int,
        receiver_stark_key: runtime_1.HexadecimalString,
        receiver_vault_id: t.Int,
        amount: runtime_1.PositiveBigNumber,
        asset_id: runtime_1.HexadecimalString,
        expiration_timestamp: t.Int,
        nonce: t.Int,
    });
    ImmutableMethodResults.ImmutableTransferResultCodec = t.type({
        transfer_id: t.Int,
        status: t.string,
        time: t.Int,
        sent_signature: t.string,
    });
    ImmutableMethodResults.ImmutableOffchainMintResultCodec = t.type({
        token_id: t.string,
        client_token_id: t.string,
        tx_id: t.Int,
    });
    ImmutableMethodResults.ImmutableOffchainMintResultsCodec = t.type({
        results: t.array(ImmutableMethodResults.ImmutableOffchainMintResultCodec),
    });
    ImmutableMethodResults.ImmutableMintFeeResultCodec = t.type({
        type: runtime_1.fromEnum('ImmutableFeeType', ImmutableFeeType),
        fee_percentage: t.Int,
        address: runtime_1.EthAddress,
    });
    ImmutableMethodResults.ImmutableGetSignableOrderResultCodec = t.type({
        stark_key: runtime_1.HexadecimalString,
        nonce: t.Int,
        expiration_timestamp: t.Int,
        amount_sell: runtime_1.PositiveBigNumber,
        asset_id_sell: runtime_1.HexadecimalString,
        vault_id_sell: t.Int,
        amount_buy: runtime_1.PositiveBigNumber,
        asset_id_buy: runtime_1.HexadecimalString,
        vault_id_buy: t.Int,
    });
    ImmutableMethodResults.ImmutableCreateOrderResultCodec = t.type({
        order_id: t.Int,
        status: t.string,
    });
    ImmutableMethodResults.ImmutableCancelOrderResultCodec = t.type({
        order_id: t.Int,
        status: t.string,
    });
    ImmutableMethodResults.ImmutableCollectionCodec = t.type({
        name: t.string,
        icon_url: t.union([t.null, t.string]),
    });
    ImmutableMethodResults.ImmutablePropertiesCodec = t.type({
        name: t.union([t.null, t.string]),
        image_url: t.union([t.null, t.string]),
        collection: ImmutableMethodResults.ImmutableCollectionCodec,
    });
    ImmutableMethodResults.ImmutableETHTokenCodec = t.interface({
        type: runtime_1.ETHTokenTypeT,
        data: t.type({
            quantity: runtime_1.PositiveBigNumber,
            // @TODO: Cannot add this type because the 'decimals' incorrectly returned
            // by the API can be '0' (https://immutable.atlassian.net/browse/IMX-3556).
            // decimals: PositiveIntegerC,
            decimals: t.Int,
        }),
    });
    ImmutableMethodResults.ImmutableERC20TokenCodec = t.interface({
        type: runtime_1.ERC20TokenTypeT,
        data: t.type({
            token_address: runtime_1.EthAddress,
            quantity: runtime_1.PositiveBigNumber,
            // @TODO: Cannot add this type because the 'decimals' incorrectly returned
            // by the API can be '0' (https://immutable.atlassian.net/browse/IMX-3556).
            // decimals: PositiveIntegerC,
            decimals: t.Int,
        }),
    });
    ImmutableMethodResults.ImmutableERC721TokenCodec = t.type({
        type: runtime_1.ERC721TokenTypeT,
        data: t.intersection([
            t.type({
                id: io_ts_types_1.NonEmptyString,
                token_address: runtime_1.EthAddress,
                quantity: runtime_1.PositiveBigNumber,
            }),
            t.partial({
                properties: ImmutableMethodResults.ImmutablePropertiesCodec,
            }),
        ]),
    });
    ImmutableMethodResults.ImmutableTokenCodec = t.union([
        ImmutableMethodResults.ImmutableETHTokenCodec,
        ImmutableMethodResults.ImmutableERC20TokenCodec,
        ImmutableMethodResults.ImmutableERC721TokenCodec,
    ]);
    ImmutableMethodResults.ImmutablePaginatedResultCodec = t.intersection([
        t.type({ cursor: t.string }),
        t.partial({ remaining: t.Int }),
    ]);
    ImmutableMethodResults.ImmutableGetOrderResultCodec = t.type({
        order_id: t.Int,
        status: exports.ImmutableOrderStatusCodec,
        user: runtime_1.EthAddress,
        sell: ImmutableMethodResults.ImmutableTokenCodec,
        buy: ImmutableMethodResults.ImmutableTokenCodec,
        amount_sold: t.union([runtime_1.PositiveBigNumber, t.null]),
        expiration_timestamp: io_ts_types_1.DateFromISOString,
        timestamp: io_ts_types_1.DateFromISOString,
    });
    ImmutableMethodResults.ImmutableGetOrdersResultCodec = t.intersection([
        t.type({
            result: t.array(ImmutableMethodResults.ImmutableGetOrderResultCodec),
        }),
        ImmutableMethodResults.ImmutablePaginatedResultCodec,
    ]);
    ImmutableMethodResults.ImmutableApplicationCodec = t.type({
        id: t.string,
        name: t.string,
        created_at: t.string,
    });
    ImmutableMethodResults.ImmutableGetApplicationsResultCodec = t.intersection([
        t.type({
            result: t.array(ImmutableMethodResults.ImmutableApplicationCodec),
        }),
        ImmutableMethodResults.ImmutablePaginatedResultCodec,
    ]);
    ImmutableMethodResults.ImmutableSellOrderCodec = t.type({
        order_id: t.number,
        user: t.string,
        buy_quantity: runtime_1.PositiveBigNumber,
        buy_decimals: t.number,
    });
    ImmutableMethodResults.ImmutableBuyOrderCodec = t.type({
        order_id: t.number,
        user: t.string,
        sell_quantity: runtime_1.PositiveBigNumber,
        sell_decimals: t.number,
    });
    ImmutableMethodResults.ImmutableAssetCodec = t.intersection([
        t.type({
            token_address: runtime_1.HexadecimalString,
            id: t.string,
            user: t.union([t.null, runtime_1.EthAddress]),
            status: exports.ImmutableAssetStatusCodec,
            uri: t.union([t.null, t.string]),
            name: t.union([t.null, t.string]),
            description: t.union([t.null, t.string]),
            image_url: t.union([t.null, t.string]),
            metadata: t.unknown,
            collection: ImmutableMethodResults.ImmutableCollectionCodec,
        }),
        t.partial({
            orders: t.partial({
                sell_orders: t.union([t.null, t.array(ImmutableMethodResults.ImmutableSellOrderCodec)]),
                buy_orders: t.union([t.null, t.array(ImmutableMethodResults.ImmutableBuyOrderCodec)]),
            }),
        }),
    ]);
    ImmutableMethodResults.ImmutableGetAssetsResultCodec = t.intersection([
        t.type({
            result: t.array(ImmutableMethodResults.ImmutableAssetCodec),
        }),
        ImmutableMethodResults.ImmutablePaginatedResultCodec,
    ]);
    // TODO: remove V2 once V1 is deprecated
    ImmutableMethodResults.ImmutableAssetV2Codec = t.intersection([
        t.type({
            token_address: runtime_1.HexadecimalString,
            id: t.string,
            user: t.union([t.null, runtime_1.EthAddress]),
            status: exports.ImmutableAssetStatusCodec,
            uri: t.union([t.null, t.string]),
            name: t.union([t.null, t.string]),
            description: t.union([t.null, t.string]),
            image_url: t.union([t.null, t.string]),
            metadata: t.unknown,
            collection: ImmutableMethodResults.ImmutableCollectionCodec,
            fees: t.array(ImmutableMethodResults.ImmutableMintFeeResultCodec),
        }),
        t.partial({
            orders: t.partial({
                sell_orders: t.union([t.null, t.array(ImmutableMethodResults.ImmutableSellOrderCodec)]),
                buy_orders: t.union([t.null, t.array(ImmutableMethodResults.ImmutableBuyOrderCodec)]),
            }),
        }),
    ]);
    ImmutableMethodResults.ImmutableGetAssetsV2ResultCodec = t.intersection([
        t.type({
            result: t.array(ImmutableMethodResults.ImmutableAssetV2Codec),
        }),
        ImmutableMethodResults.ImmutablePaginatedResultCodec,
    ]);
    ImmutableMethodResults.ImmutableGetCollectionsResultCodec = t.intersection([
        t.type({
            result: t.array(ImmutableMethodResults.ImmutableCollectionCodec),
        }),
        ImmutableMethodResults.ImmutablePaginatedResultCodec,
    ]);
    ImmutableMethodResults.ImmutableCreateTradeResultCodec = t.type({
        trade_id: t.Int,
        status: t.string,
    });
    ImmutableMethodResults.ImmutableDepositCodec = t.type({
        transaction_id: t.Int,
        status: exports.ImmutableTransactionStatusCodec,
        user: runtime_1.EthAddress,
        token: ImmutableMethodResults.ImmutableTokenCodec,
        timestamp: io_ts_types_1.DateFromISOString,
    });
    ImmutableMethodResults.ImmutableGetDepositsResultCodec = t.intersection([
        t.type({
            result: t.array(ImmutableMethodResults.ImmutableDepositCodec),
        }),
        ImmutableMethodResults.ImmutablePaginatedResultCodec,
    ]);
    ImmutableMethodResults.ImmutableWithdrawalCodec = t.type({
        transaction_id: t.Int,
        sender: runtime_1.EthAddress,
        status: exports.ImmutableTransactionStatusCodec,
        timestamp: io_ts_types_1.DateFromISOString,
        rollup_status: exports.ImmutableRollupStatusCodec,
        withdrawn_to_wallet: t.boolean,
        token: ImmutableMethodResults.ImmutableTokenCodec,
    });
    ImmutableMethodResults.ImmutableGetWithdrawalsResultCodec = t.intersection([
        t.type({
            result: t.array(ImmutableMethodResults.ImmutableWithdrawalCodec),
        }),
        ImmutableMethodResults.ImmutablePaginatedResultCodec,
    ]);
    ImmutableMethodResults.ImmutableTransferCodec = t.type({
        transaction_id: t.Int,
        status: exports.ImmutableTransactionStatusCodec,
        user: runtime_1.EthAddress,
        receiver: runtime_1.EthAddress,
        token: ImmutableMethodResults.ImmutableTokenCodec,
        timestamp: io_ts_types_1.DateFromISOString,
    });
    ImmutableMethodResults.ImmutableGetTransfersResultCodec = t.intersection([
        t.type({
            result: t.array(ImmutableMethodResults.ImmutableTransferCodec),
        }),
        ImmutableMethodResults.ImmutablePaginatedResultCodec,
    ]);
    ImmutableMethodResults.ImmutableTradeCodec = t.type({
        a: t.type({
            order_id: t.Int,
            sold: runtime_1.PositiveIntegerStringC,
        }),
        b: t.type({
            order_id: t.Int,
            sold: runtime_1.PositiveIntegerStringC,
        }),
        status: exports.ImmutableTransactionStatusCodec,
        timestamp: io_ts_types_1.DateFromISOString,
        transaction_id: t.Int,
    });
    ImmutableMethodResults.ImmutableGetTradesResultCodec = t.intersection([
        t.type({
            result: t.array(ImmutableMethodResults.ImmutableTradeCodec),
        }),
        ImmutableMethodResults.ImmutablePaginatedResultCodec,
    ]);
    ImmutableMethodResults.ImmutableGetTokenResultCodec = t.type({
        token_address: t.union([t.string, runtime_1.EthAddress]),
        image_url: t.union([t.null, t.string]),
        name: t.union([t.null, t.string]),
        decimals: t.string,
        quantum: t.string,
        symbol: t.string,
    });
    ImmutableMethodResults.ImmutableListTokensResultCodec = t.intersection([
        t.type({ result: t.array(ImmutableMethodResults.ImmutableGetTokenResultCodec) }),
        ImmutableMethodResults.ImmutablePaginatedResultCodec,
    ]);
    // TODO: remove once v1 is deprecated, this is for backwards compatibility
    ImmutableMethodResults.ImmutableGetBalancesResultCodec = t.type({
        imx: runtime_1.NonNegativeBigNumber,
        preparing_withdrawal: runtime_1.NonNegativeBigNumber,
        withdrawable: runtime_1.NonNegativeBigNumber,
    });
    ImmutableMethodResults.ImmutableBalanceCodec = t.type({
        symbol: t.string,
        balance: runtime_1.NonNegativeBigNumber,
        preparing_withdrawal: runtime_1.NonNegativeBigNumber,
        withdrawable: runtime_1.NonNegativeBigNumber,
    });
    ImmutableMethodResults.ImmutableGetBalanceResultCodec = ImmutableMethodResults.ImmutableBalanceCodec;
    ImmutableMethodResults.ImmutableListBalancesResultCodec = t.intersection([
        t.type({ result: t.array(ImmutableMethodResults.ImmutableBalanceCodec) }),
        ImmutableMethodResults.ImmutablePaginatedResultCodec,
    ]);
    ImmutableMethodResults.ImmutableGetMintableTokenResultCodec = t.type({
        token_id: runtime_1.HexadecimalString,
        client_token_id: t.string,
        blueprint: t.string,
    });
})(ImmutableMethodResults = exports.ImmutableMethodResults || (exports.ImmutableMethodResults = {}));
